import numpy as np
import math

class RandomForestLearner(object):

    def __init__(self,k): 		# constructor of the class RandomForestLearner, takes two arguments,)k is sent from the program,it is the number of trees that will be in the forest  
        self.k = k					# inside of the constructor we declare the 
		                   #attributes/properties of the class. This class takes two
        self.forest = None			# two properties k=trees and forest.
		#Forest is at the begining None, and the k is sent from the main program

    def ToLearn(self,xTrain,yTrain):	# function toLearn takes two arguments arrays xTrain and yTrain.
        data = np.zeros([xTrain.shape[0],xTrain.shape[1]+1])	#inside of the function variable 'data' will be made to a matrix of dimensions(x = dimension x of xTrain, y = dimension of y of xTrain + 1) and it will be populated with all zeros, np.zeros
        data[:,0:xTrain.shape[1]]=xTrain #	lets name the data like this data(i,j) where 'i' are rows and 'j' columns. So in every row 'i' for column from 0 till y dimension of xTrain-1, put the whole xTrain
        data[:,(xTrain.shape[1])]=yTrain[:,0] #for data in every row 'i' and in colum xTrain.shape[1] put yTrains first column.
        #data just received the values of Xtrain and Ytrain from the program;the training set        
        forest = [] #declare new variable forest like a empty array.
        for i in range(0, self.k): #for loop from 0 till k-1
            #first, choose random 60%
            baggingData = self.chooseRandom(data) #call class function chooseRandom which will take the previously declared data and put the return statement in baggingData
            tree = self.makeTree(baggingData, 1) #call class function makeTree which will take baggingData and the index=1.
            forest.append(tree)					  #every iteration add the tree to the forest array.
        
        self.forest = np.array(forest)			  #the class property forest will take the previously calculated forest but like a numpy array, not like regular array.
        #print "forest", self.k, self.forest

    def chooseRandom(self, data):				# creating class function called chooseRandom which like an input argument takes matrix data
        randData = data.copy()					# make a copy of the input data so we won't directly change the input. 
        for i in range(0, int(randData.shape[0] * 0.6)): # start looping from 0 till the number of rows in randData times 0.6. If it comes that thats a float/double number, cast it to int.
            j = np.random.randint(randData.shape[0]-i, size=1) # 'j' will take a random int (np.random.randint) from between values the two values declared inside of the function, 
            temp = randData[i+j,:].copy()	#make a copy of the randomData. Only take the row i+j, and all the columns. Basicaly we made a new 1 dimensional array
            randData[i+j,:] = randData[i,:]	#in the row we previously took set the values from the row 'i'
            randData[i,:] = temp			#and the temp data put in the place of the row 'i'.
			#the above 3 lines should change the place of two arrays. You make a temporary(temp) object will store your data, you overwrite the original data with the exchange data, and after that you overwrite the exchange data with the content of the temp file
        return randData[0:int(randData.shape[0] * 0.6), :] #return rows from 0 to randData.shape[0] * 0.6 casted to int. with all its columns
        
                  
    def makeTree(self, data, index):	#function makeTree which takes data and index
        if(data.shape[0] == 1):	#first you need to check if the number of rows in data is 1;
            return [index, -1, data[0, -1], -1, -1]      # if yes, you return default value which will later show you that the function did not do its part
        else:# if not
            leftData = [] #make two arrays leftData and rightData.
            rightData = []

            while(len(leftData) == 0 or len(rightData) == 0):	#do the below code
			#until the length of lefData or RightData is 0.
                leftData = []	#leftData and rightData put to empty arrays.
                rightData = []
                randomFactor = np.random.randint(2, size = 1) #make a randomFactor 
				#which will be generated each loop to random number between 2 and 1
                factor = randomFactor[0]	

                #If you encounter data where all the values for a particular
                #feature are the same (therefore can't split the data)
                #convert the node to be a leaf node with the value being
                #the mean of the Ys.
                equalValue = True # set equalValue to true
                for i in range(1, data.shape[0]):	#loop a for loop from 
				#0 to number of rows of data - 1
                    if(data[i, factor] != data[i-1, factor]): 
					#if the nearby members are not equal i and i-1
                        equalValue=False	#equalValue set to False

                if(equalValue): #if they are equal
                    yValue = np.mean(data[:,-1])  	#then the yValue will take the mean(average) of the last column in data                
                    return [index, -1, yValue, -1, -1] # and it will return an array from which we extract data

                else:	#if they are not equal
                    randomSplit = np.random.randint(data.shape[0], size = 2)	#generate again a random data
                    splitValue = (data[randomSplit[0], factor] + data[randomSplit[1], factor]) / 2.0	#calculating splitValue of data elements which are on the defined places devided by 2

                    for i in range(0, data.shape[0]):	#also if it is not equal go through the for loop and ask 
                        if(data[i, factor] <= splitValue): #if data element on the defined place is less or equal from splitValue, if yes
                            leftData.append(data[i, :])	#append the row to left data
                        else:							#if not
                            rightData.append(data[i, :]) #append it to right data
                    leftData = np.array(leftData)	#after that convert leftData and rightData to np.array
                    rightData = np.array(rightData)

            leftTree = self.makeTree(leftData, index+1) # call again this function with leftData and index + 1 and return value put in the leftTree. This is done recursively
            left = np.array(leftTree)	#left will take the return data of the recursive data and turn it in np.array
            left= left.reshape(-1,5)	#we will rearrange the shape of the left to an array

            rightTree = self.makeTree(rightData, index + left.shape[0] + 1)	#the same thing done for the left part is done for the right, just the index is now index + 1+ length of the rows of the left.
            right = np.array(rightTree)	#convert to numpy array
            right= right.reshape(-1,5) #rearrange the shape

            tree = []		#make an array tree
            node = np.array([index, factor+1, splitValue, index+1, index + left.shape[0] + 1]) #make a value node which will be an np array with declared values
            node = [node[0], node[1], node[2], node[3], node[4]]	#the node is now from numpy array converted to regular array so it could be appended
            tree.append(node)	#appending the node to the tree

            for row in left:	#for each row in left array
                lnode = [row[0],row[1],row[2],row[3],row[4]]	#make a left node and append it to tree
                tree.append(lnode)

            for row in right:	#for each row in right array
                rnode = [row[0],row[1],row[2],row[3],row[4]]	#make a right node and append it to the tree
                tree.append(rnode)
            
            return tree	#return the tree
                
    def query(self,xTest):	#internal function of the class which takes one argument xTest (the testing features set)
        result = np.zeros([xTest.shape[0],xTest.shape[1]+1])    # make a matrix of zeros which will be dimensions of xTest rows and Xtest columns +1    
        result[:,0:xTest.shape[1]] = xTest[:,0:xTest.shape[1]]	# the zeros in result which are in each row for columns from 0 to dimension of xTest columns, take the value of xTest on the same places

        for m in range(0,xTest.shape[0]):	#go through for loop which goes from 0 to xTest row dimension.
            test = xTest[m]					#the new array called test will take the elements from the xTest row m.

            val = []						#create a new val array
            for i in range (0, self.k):		#and go through the for loop with values from 0 to k-1
                value = self.findInTree(test, self.forest[i])	#value will take the return value of the function findInTree()
                val.append(value)			# append the value to val array

            value = np.mean(val)	#calculate the mean(average) of the val
            result[m, xTest.shape[1]] = value # and put the value on the place in result

        return result #return the result


    def findInTree(self, test, forest):	#declaring a new class function which takes two arguments, beside self
        forest = np.array(forest) #the arrgument forest is type array, and here it is converting to numpy array.
        factor = forest[0, 1]	#factor is placed on the position 0,1 in forest
        index = 1	#index is declared to default value of 1

        while(factor != -1):	#do the below code until the factor is equal to 1
            splitVal = forest[index - 1, 2]	#take the splitValue from forest which is on place index-1, 2
            if(test[factor - 1] <= splitVal):	#if element in test on position factor-1 is less or equal splitValue then
                index = forest[index - 1, 3]	#index should take the value which is on the declared position in forest index-1, 3
            else:								#if not
                index = forest[index - 1, 4]	# it should take the value on position index-1, 4

            factor = forest[index - 1, 1] #and the factor should take value from the position index-1,1

        return forest[index - 1, 2]		#after everything, return the element from forest on position index-1,2
		
		
### although some of the comments may seem very basic, it helps in visualization in my opinion##